macro "PhytolithsBatch [P]"{


function binarize(sDir, t)
{
         //make sure type is 8-bit
         run("8-bit");
         setAutoThreshold("Default");

         //run("Threshold...");
         setThreshold(0, 0);
         setOption("BlackBackground", false);
         run("Convert to Mask");

       // setTool("floodfill");
        waitForUser("Please fill in the background to black\nthen click okay");  

         //make it binary
         run("Make Binary");

         //Save file in the saveDirectory with title t
         saveAs("Tiff", sDir+File.separator+"Binary_"+t);
}



openDir=getDirectory("Choose a Folder of Images to be Analyzed");
list = getFileList(openDir);

 //display dialog with options
     start_options=newArray("Start with first image","Choose starting image. (Prior images will be skipped)");
     Dialog.create("Startup Options");
     Dialog.addRadioButtonGroup("Options", start_options, 2, 1, "Start with first image");
     Dialog.addCheckbox("Choose Save Directory", false);
     Dialog.show;
     start_choice = Dialog.getRadioButton();
     save_choice = Dialog.getCheckbox();

saveDir = openDir+File.separator+"BinaryImages";
dupFolder=true;
while(dupFolder == true)
{
   if (File.isDirectory(saveDir))
   {
       saveDir=saveDir+"(1)"; 
   }
   else
       dupFolder=false;
}
   File.makeDirectory(saveDir+File.separator);

start=0;
if(start_choice == "Choose starting image. (Prior images will be skipped)")
{
   i = start;
   found=false;
   //open dialog and get image file name
   start_image=File.openDialog("Choose Starting Image");
   //compare file names to find match
   while(i<list.length&&found==false)
   {
      if(endsWith(start_image, list[i]))
	found = true;
      else
	i++;
   }
   start=i;
}

//save options dialog
if(save_choice==true)
{
     saveDir=getDirectory("Choose a Folder to Save Binary Images in");
}

end=list.length;
setBatchMode(false);
count = 0;
for(i=start; i<end; i++)
{
   path = openDir+list[i];
   showProgress((i-start), list.length);

 if(endsWith(path, "tif")||endsWith(path, "tiff")||endsWith(path, "jpg")||endsWith(path, "jpeg")||endsWith(path, "raw")||endsWith(path, "bmp")||endsWith(path, "png")
||endsWith(path, "TIF")||endsWith(path, "TIFF")||endsWith(path, "JPG")||endsWith(path, "JPEG")||endsWith(path, "RAW")||endsWith(path, "BMP")||endsWith(path, "PNG"))
 { 
     count++;
     //On the first image, if start = 0 change start to be the first (current) image
     if(count==1 && start==0)
     {
         start = i;
     }
     //Save list[i] in array redoOptions
  do//while(redo==true)
  {
     redo = false;
     open(path);
     title = getTitle();

     //pause and let user do stuff
     do //while(redirected==true)
     {
     redirected = false;
     setColor(255,255,255);
     waitForUser("Click okay when done tracing (for options)");
     //Allow user to choose done, redo, skip, or go back
     //display dialog with options
     options=newArray("Done: Continue With Images","Done: Analyze Now - Skip Subsequent Images","Skip This Image", "Redo", "Redo Previous Image");
     Dialog.create("Options");
     Dialog.addRadioButtonGroup("Options", options, 5, 1, "Done: Continue With Images");
     Dialog.show;
     choice = Dialog.getRadioButton();

     if(choice=="Done: Analyze Now - Skip Subsequent Images")
     {
         done=true;
         redo=false;
         redirected=false;
         end = i;
         binarize(saveDir, title);
     }

     if(choice=="Done: Continue With Images")
     {
         done=true;
         redo=false;
         redirected=false;
         binarize(saveDir, title);
     }

     if(choice=="Redo")
     {
         redo = true;
         redirected=false;
     }

     if(choice=="Skip")
     {
         redirected=false;
         redo=false;
     }

     if(choice=="Redo Previous Image")
     {
         //Only allow user to choose image files to redo
         //if there are no previous image files, display appropriate message and continue with current image
         options2 = newArray();
         no_prev = true;
         redirected=true;

         for(j=start; j<i; j++)
         {
	redo_image_path = openDir+list[j];
	 if(endsWith(path, "tif")||endsWith(path, "tiff")||endsWith(path, "jpg")||endsWith(path, "jpeg")||endsWith(path, "raw")||endsWith(path, "bmp")||endsWith(path, "png")
||endsWith(path, "TIF")||endsWith(path, "TIFF")||endsWith(path, "JPG")||endsWith(path, "JPEG")||endsWith(path, "RAW")||endsWith(path, "BMP")||endsWith(path, "PNG"))
	{
	    options2=Array.concat(options2,list[j]);
	    no_prev=false;
	}
          }
     options2=Array.concat(options2,"Return to Current Image");
     if(no_prev==true)
     {
          Dialog.create("Redo Previous Image")
          Dialog.addMessage("There are no previous images to redo.");
          Dialog.show();
      }
     else
     {
         //display dialog - redo choices
         Dialog.create("Redo Options");
         Dialog.addMessage("Current changes will be not saved.\nThis image will remain open.\nYou will be redirected back to this image.");
         Dialog.addRadioButtonGroup("Options",options2,(i-start+1),1,"Return to Current Image");
         Dialog.show();
         choice=Dialog.getRadioButton;

         if(choice=="Return to Current Image")
         {
	redo2=false;	    
         }
         //change path to specified redo image
         else
         {
	new_path = openDir+choice;
	redo2=true;
         }

         while(redo2==true)
         {
            redo2=false;
	open(new_path);
	redo_title = getTitle();


	//pause and let user do stuff
	waitForUser("Click okay when done tracing (for options)");
     
	//Allow user to choose replace, skip, or redo
	options=newArray("Done: Replace Image","Skip: Don't Replace", "Redo");
	Dialog.create("Options");
	Dialog.addRadioButtonGroup("Options", options, 3, 1, "Done: Replace Image");
	Dialog.show;
	choice = Dialog.getRadioButton();

	if(choice=="Done: Replace Image")
	{
	   //delete old binary
	   if(File.exists(saveDir+File.separator+"Binary_"+title))
	   {
	       File.delete(saveDir+File.separator+"Binary_"+title);
	    }
	   binarize(saveDir, redo_title);
	}
	if(choice=="Redo")
	{
	   redo2=true;
	}
	if(choice=="Skip: Don't Replace")
            {
	    //redo2=false;
	}
	close();
         }//end of do while loop "open image and let user do stuff - previous image"

     }//end of else statement "previous images exist"

        //continue with open, unsaved image
        selectWindow(title);

     }//end if statement "redo previous image"


     }while(redirected==true)//end do while loop "let user do stuff"   

     close();

  }while(redo==true);//end do while loop "redo image"

 }//end if statement "is image file"
   
}//end for loop "next image"

saveDir = saveDir+File.separator;
//Analyze Files using Phytoliths_ plugin
  requires("1.33n and a square pixel binary image");
  list = getFileList(saveDir);

  setBatchMode(true);
  waitForUser("If you have not calibrated, please do so now");

  for(i=0; i<list.length; i++)
  {
     path = saveDir+list[i];

     if(endsWith(path, "tif")||endsWith(path, "tiff")||endsWith(path, "TIF")||endsWith(path, "TIFF"))
     {
      open(path);
      title = getTitle();
       //make sure it is a newly created binary file
       if("Binary_"==substring(title,0,7))
       {
          print(i+":   "+list[i]);
          showProgress(i, list.length);
          run("8-bit"); //make sure it is 8-bit

          getPixelSize(unit, pw, ph, pd); //get global calibration
          cal = 1/pw;
  
          if(unit=="um")
          {
  	     unit = getInfo("micrometer.abbreviation");
          }
          if(pw!=ph)
          {
     	  write("Not Square Pixels - Cannot Analyze");
  	  print("Did not Analyze:   "+list[i]);
          }	
          else
          {
	  
  	  run("Phytoliths ", "  minimum=0 maximum=9999999 display redirect=None pixels/unit=cal units=unit");
          }  
          saveAs("results", saveDir+File.separator+"Results");
          //run("Save");
          close();
        }
      }
    }
   if(list.length==0)
   {
      Dialog.create("End");
      Dialog.addMessage("No Binary Images to Analyze. Program Done.");   
      Dialog.show();
   }

}

